# References

## Carnegie-Mellon Software Engineering Institute

- [Signed Integer Overflow](https://wiki.sei.cmu.edu/confluence/display/c/INT32-C.+Ensure+that+operations+on+signed+integers+do+not+result+in+overflow)
- [Unsigned Integer Wrapping](https://wiki.sei.cmu.edu/confluence/display/c/INT30-C.+Ensure+that+unsigned+integer+operations+do+not+wrap)

## Lectures

- [Secure Coding (Integer Security)](http://www.sis.pitt.edu/jjoshi/courses/IS2620/Spring07/Lecture6.pdf)
- [Integer Arithmetic and Undefined Behavior](http://www0.cs.ucl.ac.uk/staff/B.Karp/3007/s2018/lectures/3007-lecture5-C-arith-undef-behav.pdf)

## Software

- [SafeInt (C++)](https://github.com/dcleblanc/SafeInt)
- [Boost SafeNumerics (C++)](https://github.com/boostorg/safe_numerics/)
